<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- Source/Synopsis/Formatters/HTML/Fragments/DeclarationFormatter.py.html -->
<!-- this view was generated by Source -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis/Formatters/HTML/Fragments/DeclarationFormatter.py</title>
<link href="../../../../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="Source">
<div class="navigation">
<span class="normal"><a href="../../../../../Scopes/Synopsis.html" >Global Package</a></span>
<span class="normal"><a href="../../../../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../../../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../../../../NameIndex.html" >Name Index</a></span>
</div>
File: <b >Synopsis/Formatters/HTML/Fragments/DeclarationFormatter.py</b><pre class="sxr"><a id="line1"></a><span class="lineno">  1</span><span class="line"><span class="py-comment">#</span></span>
<a id="line2"></a><span class="lineno">  2</span><span class="line"><span class="py-comment"># Copyright (C) 2000 Stephen Davies</span></span>
<a id="line3"></a><span class="lineno">  3</span><span class="line"><span class="py-comment"># Copyright (C) 2000 Stefan Seefeld</span></span>
<a id="line4"></a><span class="lineno">  4</span><span class="line"><span class="py-comment"># All rights reserved.</span></span>
<a id="line5"></a><span class="lineno">  5</span><span class="line"><span class="py-comment"># Licensed to the public under the terms of the GNU LGPL (&gt;= 2),</span></span>
<a id="line6"></a><span class="lineno">  6</span><span class="line"><span class="py-comment"># see the file COPYING for details.</span></span>
<a id="line7"></a><span class="lineno">  7</span><span class="line"><span class="py-comment">#</span></span>
<a id="line8"></a><span class="lineno">  8</span>
<a id="line9"></a><span class="lineno">  9</span><span class="line"><span class="py-keyword">from</span> Synopsis <span class="py-keyword">import</span> ASG</span>
<a id="line10"></a><span class="lineno"> 10</span><span class="line"><span class="py-keyword">from</span> Synopsis.Formatters.HTML.Fragment <span class="py-keyword">import</span> Fragment</span>
<a id="line11"></a><span class="lineno"> 11</span><span class="line"><span class="py-keyword">from</span> Synopsis.Formatters.HTML.Tags <span class="py-keyword">import</span> *</span>
<a id="line12"></a><span class="lineno"> 12</span><span class="line"><span class="py-keyword">from</span> SourceLinker <span class="py-keyword">import</span> SourceLinker</span>
<a id="line13"></a><span class="lineno"> 13</span><span class="line"><span class="py-keyword">from</span> XRefLinker <span class="py-keyword">import</span> XRefLinker</span>
<a id="line14"></a><span class="lineno"> 14</span>
<a id="line15"></a><span class="lineno"> 15</span><span class="line"><span class="py-keyword">class</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Fragments/DeclarationFormatter/DeclarationFormatter.html">DeclarationFormatter</a>(Fragment):</span>
<a id="line16"></a><span class="lineno"> 16</span><span class="line">    <span class="py-string">&quot;&quot;&quot;Base class for SummaryFormatter and DetailFormatter.</span></span>
<a id="line17"></a><span class="lineno"> 17</span><span class="line"><span class="py-string">    </span></span>
<a id="line18"></a><span class="lineno"> 18</span><span class="line"><span class="py-string">    The two classes SummaryFormatter and DetailFormatter are actually</span></span>
<a id="line19"></a><span class="lineno"> 19</span><span class="line"><span class="py-string">    very similar in operation, and so most of their methods are defined here.</span></span>
<a id="line20"></a><span class="lineno"> 20</span><span class="line"><span class="py-string">    Both of them print out the definition of the declarations, including type,</span></span>
<a id="line21"></a><span class="lineno"> 21</span><span class="line"><span class="py-string">    parameters, etc. Some things such as exception specifications are only</span></span>
<a id="line22"></a><span class="lineno"> 22</span><span class="line"><span class="py-string">    printed out in the detailed version.</span></span>
<a id="line23"></a><span class="lineno"> 23</span><span class="line"><span class="py-string">    &quot;&quot;&quot;</span></span>
<a id="line24"></a><span class="lineno"> 24</span>
<a id="line25"></a><span class="lineno"> 25</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Fragments/DeclarationFormatter/DeclarationFormatter.html#register">register</a>(self, formatter):</span>
<a id="line26"></a><span class="lineno"> 26</span>
<a id="line27"></a><span class="lineno"> 27</span><span class="line">        super(DeclarationFormatter, self).register(formatter)</span>
<a id="line28"></a><span class="lineno"> 28</span><span class="line">        <span class="py-keyword">if</span> self.processor.has_view(<span class="py-string">'XRef'</span>):</span>
<a id="line29"></a><span class="lineno"> 29</span><span class="line">            self.xref = XRefLinker()</span>
<a id="line30"></a><span class="lineno"> 30</span><span class="line">            self.xref.register(formatter)</span>
<a id="line31"></a><span class="lineno"> 31</span><span class="line">        <span class="py-keyword">else</span>:</span>
<a id="line32"></a><span class="lineno"> 32</span><span class="line">            self.xref = None</span>
<a id="line33"></a><span class="lineno"> 33</span><span class="line">        <span class="py-keyword">if</span> self.processor.has_view(<span class="py-string">'Source'</span>):</span>
<a id="line34"></a><span class="lineno"> 34</span><span class="line">            self.source = SourceLinker()</span>
<a id="line35"></a><span class="lineno"> 35</span><span class="line">            self.source.register(formatter)</span>
<a id="line36"></a><span class="lineno"> 36</span><span class="line">        <span class="py-keyword">else</span>:</span>
<a id="line37"></a><span class="lineno"> 37</span><span class="line">            self.source = None</span>
<a id="line38"></a><span class="lineno"> 38</span>
<a id="line39"></a><span class="lineno"> 39</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Fragments/DeclarationFormatter/DeclarationFormatter.html#format_parameters">format_parameters</a>(self, parameters):</span>
<a id="line40"></a><span class="lineno"> 40</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Returns formatted string for the given parameter list.&quot;&quot;&quot;</span></span>
<a id="line41"></a><span class="lineno"> 41</span>
<a id="line42"></a><span class="lineno"> 42</span><span class="line">        <span class="py-keyword">return</span> <span class="py-string">', '</span>.join([self.format_parameter(p) <span class="py-keyword">for</span> p <span class="py-keyword">in</span> parameters])</span>
<a id="line43"></a><span class="lineno"> 43</span>
<a id="line44"></a><span class="lineno"> 44</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Fragments/DeclarationFormatter/DeclarationFormatter.html#format_declaration">format_declaration</a>(self, decl):</span>
<a id="line45"></a><span class="lineno"> 45</span><span class="line">        <span class="py-string">&quot;&quot;&quot;The default is to return no type and just the declarations name for</span></span>
<a id="line46"></a><span class="lineno"> 46</span><span class="line"><span class="py-string">        the name.&quot;&quot;&quot;</span></span>
<a id="line47"></a><span class="lineno"> 47</span>
<a id="line48"></a><span class="lineno"> 48</span><span class="line">        <span class="py-keyword">return</span> div(<span class="py-string">'synopsis'</span>, self.label(decl.name))</span>
<a id="line49"></a><span class="lineno"> 49</span>
<a id="line50"></a><span class="lineno"> 50</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Fragments/DeclarationFormatter/DeclarationFormatter.html#format_macro">format_macro</a>(self, decl):</span>
<a id="line51"></a><span class="lineno"> 51</span><span class="line">        <span class="py-string">&quot;&quot;&quot;&quot;&quot;&quot;</span></span>
<a id="line52"></a><span class="lineno"> 52</span>
<a id="line53"></a><span class="lineno"> 53</span><span class="line">        chunk = div(<span class="py-string">'synopsis'</span>, self.label(decl.name))</span>
<a id="line54"></a><span class="lineno"> 54</span><span class="line">        <span class="py-keyword">if</span> self.xref: chunk += <span class="py-string">' %s'</span>%div(<span class="py-string">'xref'</span>, self.xref.format_macro(decl))</span>
<a id="line55"></a><span class="lineno"> 55</span><span class="line">        <span class="py-keyword">if</span> self.source: chunk += <span class="py-string">' %s'</span>%div(<span class="py-string">'source'</span>, self.source.format_macro(decl))</span>
<a id="line56"></a><span class="lineno"> 56</span><span class="line">        <span class="py-keyword">return</span> chunk</span>
<a id="line57"></a><span class="lineno"> 57</span>
<a id="line58"></a><span class="lineno"> 58</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Fragments/DeclarationFormatter/DeclarationFormatter.html#format_forward">format_forward</a>(self, decl):</span>
<a id="line59"></a><span class="lineno"> 59</span>
<a id="line60"></a><span class="lineno"> 60</span><span class="line">        <span class="py-comment"># treat template syntax like a premodifier</span></span>
<a id="line61"></a><span class="lineno"> 61</span><span class="line">        <span class="py-keyword">if</span> decl.template:</span>
<a id="line62"></a><span class="lineno"> 62</span><span class="line">            templ = <span class="py-string">'template &amp;lt;%s&amp;gt;'</span>%(self.format_parameters(decl.template.parameters),)</span>
<a id="line63"></a><span class="lineno"> 63</span><span class="line">            templ = div(<span class="py-string">'template'</span>, templ)</span>
<a id="line64"></a><span class="lineno"> 64</span><span class="line">            type = <span class="py-string">'%s %s'</span>%(templ, decl.type)</span>
<a id="line65"></a><span class="lineno"> 65</span><span class="line">        <span class="py-keyword">else</span>:</span>
<a id="line66"></a><span class="lineno"> 66</span><span class="line">            type = decl.type</span>
<a id="line67"></a><span class="lineno"> 67</span>
<a id="line68"></a><span class="lineno"> 68</span><span class="line">        <span class="py-keyword">if</span> decl.specializations:</span>
<a id="line69"></a><span class="lineno"> 69</span><span class="line">            <span class="py-comment"># Treat it like a (non-forward declared) class template.</span></span>
<a id="line70"></a><span class="lineno"> 70</span><span class="line">            name  = self.format_scope(decl)</span>
<a id="line71"></a><span class="lineno"> 71</span><span class="line">        <span class="py-keyword">else</span>:</span>
<a id="line72"></a><span class="lineno"> 72</span><span class="line">            name = self.label(decl.name)</span>
<a id="line73"></a><span class="lineno"> 73</span><span class="line">        chunk = div(<span class="py-string">'synopsis'</span>, type + <span class="py-string">' '</span> + name)</span>
<a id="line74"></a><span class="lineno"> 74</span><span class="line">        <span class="py-keyword">if</span> self.xref: chunk += <span class="py-string">' %s'</span>%div(<span class="py-string">'xref'</span>, self.xref.format_forward(decl))</span>
<a id="line75"></a><span class="lineno"> 75</span><span class="line">        <span class="py-keyword">if</span> self.source: chunk += <span class="py-string">' %s'</span>%div(<span class="py-string">'source'</span>, self.source.format_forward(decl))</span>
<a id="line76"></a><span class="lineno"> 76</span><span class="line">        <span class="py-keyword">return</span> chunk</span>
<a id="line77"></a><span class="lineno"> 77</span>
<a id="line78"></a><span class="lineno"> 78</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Fragments/DeclarationFormatter/DeclarationFormatter.html#format_group">format_group</a>(self, decl):</span>
<a id="line79"></a><span class="lineno"> 79</span>
<a id="line80"></a><span class="lineno"> 80</span><span class="line">        <span class="py-keyword">return</span> <span class="py-string">''</span></span>
<a id="line81"></a><span class="lineno"> 81</span>
<a id="line82"></a><span class="lineno"> 82</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Fragments/DeclarationFormatter/DeclarationFormatter.html#format_scope">format_scope</a>(self, decl):</span>
<a id="line83"></a><span class="lineno"> 83</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Scopes have their own views, so return a reference to it.&quot;&quot;&quot;</span></span>
<a id="line84"></a><span class="lineno"> 84</span>
<a id="line85"></a><span class="lineno"> 85</span><span class="line">        name = decl.name</span>
<a id="line86"></a><span class="lineno"> 86</span><span class="line">        link = rel(self.formatter.filename(),</span>
<a id="line87"></a><span class="lineno"> 87</span><span class="line">                   self.directory_layout.scope(name))</span>
<a id="line88"></a><span class="lineno"> 88</span><span class="line">        <span class="py-keyword">return</span> href(link, escape(name[-1]))</span>
<a id="line89"></a><span class="lineno"> 89</span>
<a id="line90"></a><span class="lineno"> 90</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Fragments/DeclarationFormatter/DeclarationFormatter.html#format_module">format_module</a>(self, decl):</span>
<a id="line91"></a><span class="lineno"> 91</span>
<a id="line92"></a><span class="lineno"> 92</span><span class="line">        <span class="py-keyword">return</span> self.format_scope(decl)</span>
<a id="line93"></a><span class="lineno"> 93</span>
<a id="line94"></a><span class="lineno"> 94</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Fragments/DeclarationFormatter/DeclarationFormatter.html#format_meta_module">format_meta_module</a>(self, decl):</span>
<a id="line95"></a><span class="lineno"> 95</span>
<a id="line96"></a><span class="lineno"> 96</span><span class="line">        <span class="py-keyword">return</span> self.format_module(decl)</span>
<a id="line97"></a><span class="lineno"> 97</span>
<a id="line98"></a><span class="lineno"> 98</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Fragments/DeclarationFormatter/DeclarationFormatter.html#format_class">format_class</a>(self, decl):</span>
<a id="line99"></a><span class="lineno"> 99</span>
<a id="line100"></a><span class="lineno">100</span><span class="line">        chunk = div(<span class="py-string">'synopsis'</span>, decl.type + <span class="py-string">' '</span> + self.format_scope(decl))</span>
<a id="line101"></a><span class="lineno">101</span><span class="line">        <span class="py-keyword">if</span> self.xref: chunk += <span class="py-string">' %s'</span>%div(<span class="py-string">'xref'</span>, self.xref.format_class(decl))</span>
<a id="line102"></a><span class="lineno">102</span><span class="line">        <span class="py-keyword">if</span> self.source: chunk += <span class="py-string">' %s'</span>%div(<span class="py-string">'source'</span>, self.source.format_class(decl))</span>
<a id="line103"></a><span class="lineno">103</span><span class="line">        <span class="py-keyword">return</span> chunk</span>
<a id="line104"></a><span class="lineno">104</span>
<a id="line105"></a><span class="lineno">105</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Fragments/DeclarationFormatter/DeclarationFormatter.html#format_class_template">format_class_template</a>(self, decl):</span>
<a id="line106"></a><span class="lineno">106</span>
<a id="line107"></a><span class="lineno">107</span><span class="line">        <span class="py-comment"># treat template syntax like a premodifier</span></span>
<a id="line108"></a><span class="lineno">108</span><span class="line">        <span class="py-keyword">if</span> decl.template:</span>
<a id="line109"></a><span class="lineno">109</span><span class="line">            templ = <span class="py-string">'template &amp;lt;%s&amp;gt;'</span>%(self.format_parameters(decl.template.parameters),)</span>
<a id="line110"></a><span class="lineno">110</span><span class="line">            templ = div(<span class="py-string">'template'</span>, templ)</span>
<a id="line111"></a><span class="lineno">111</span><span class="line">            type = <span class="py-string">'%s %s'</span>%(templ, decl.type)</span>
<a id="line112"></a><span class="lineno">112</span>
<a id="line113"></a><span class="lineno">113</span><span class="line">        name  = self.format_scope(decl)</span>
<a id="line114"></a><span class="lineno">114</span><span class="line">        chunk = div(<span class="py-string">'synopsis'</span>, type + <span class="py-string">' '</span> + name)</span>
<a id="line115"></a><span class="lineno">115</span><span class="line">        <span class="py-keyword">if</span> self.xref: chunk += <span class="py-string">' %s'</span>%div(<span class="py-string">'xref'</span>, self.xref.format_class(decl))</span>
<a id="line116"></a><span class="lineno">116</span><span class="line">        <span class="py-keyword">if</span> self.source: chunk += <span class="py-string">' %s'</span>%div(<span class="py-string">'source'</span>, self.source.format_class(decl))</span>
<a id="line117"></a><span class="lineno">117</span><span class="line">        <span class="py-keyword">return</span> chunk</span>
<a id="line118"></a><span class="lineno">118</span>
<a id="line119"></a><span class="lineno">119</span>
<a id="line120"></a><span class="lineno">120</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Fragments/DeclarationFormatter/DeclarationFormatter.html#format_typedef">format_typedef</a>(self, decl):</span>
<a id="line121"></a><span class="lineno">121</span><span class="line">        <span class="py-string">&quot;(typedef type, typedef name)&quot;</span></span>
<a id="line122"></a><span class="lineno">122</span>
<a id="line123"></a><span class="lineno">123</span><span class="line">        type = self.format_type(decl.alias)</span>
<a id="line124"></a><span class="lineno">124</span><span class="line">        chunk = <span class="py-string">'%s'</span>%div(<span class="py-string">'synopsis'</span>, type + <span class="py-string">' '</span> + self.label(decl.name))</span>
<a id="line125"></a><span class="lineno">125</span><span class="line">        <span class="py-keyword">if</span> self.xref: chunk += <span class="py-string">' %s'</span>%div(<span class="py-string">'xref'</span>, self.xref.format_class(decl))</span>
<a id="line126"></a><span class="lineno">126</span><span class="line">        <span class="py-keyword">if</span> self.source: chunk += <span class="py-string">' %s'</span>%div(<span class="py-string">'source'</span>, self.source.format_class(decl))</span>
<a id="line127"></a><span class="lineno">127</span><span class="line">        <span class="py-keyword">return</span> chunk</span>
<a id="line128"></a><span class="lineno">128</span>
<a id="line129"></a><span class="lineno">129</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Fragments/DeclarationFormatter/DeclarationFormatter.html#format_enumerator">format_enumerator</a>(self, decl):</span>
<a id="line130"></a><span class="lineno">130</span><span class="line">        <span class="py-string">&quot;&quot;&quot;This is only called by formatEnum&quot;&quot;&quot;</span></span>
<a id="line131"></a><span class="lineno">131</span>
<a id="line132"></a><span class="lineno">132</span><span class="line">        self.format_declaration(decl)</span>
<a id="line133"></a><span class="lineno">133</span>
<a id="line134"></a><span class="lineno">134</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Fragments/DeclarationFormatter/DeclarationFormatter.html#format_enum">format_enum</a>(self, decl):</span>
<a id="line135"></a><span class="lineno">135</span><span class="line">        <span class="py-string">&quot;(enum name, list of enumerator names)&quot;</span></span>
<a id="line136"></a><span class="lineno">136</span>
<a id="line137"></a><span class="lineno">137</span><span class="line">        type = self.label(decl.name)</span>
<a id="line138"></a><span class="lineno">138</span><span class="line">        name = <span class="py-string">', '</span>.join([e.name[-1] <span class="py-keyword">for</span> e <span class="py-keyword">in</span> decl.enumerators])</span>
<a id="line139"></a><span class="lineno">139</span><span class="line">        chunk = <span class="py-string">'%s'</span>%div(<span class="py-string">'synopsis'</span>, type + <span class="py-string">' '</span> + name)</span>
<a id="line140"></a><span class="lineno">140</span><span class="line">        <span class="py-keyword">if</span> self.xref: chunk += <span class="py-string">' %s'</span>%div(<span class="py-string">'xref'</span>, self.xref.format_class(decl))</span>
<a id="line141"></a><span class="lineno">141</span><span class="line">        <span class="py-keyword">if</span> self.source: chunk += <span class="py-string">' %s'</span>%div(<span class="py-string">'source'</span>, self.source.format_class(decl))</span>
<a id="line142"></a><span class="lineno">142</span><span class="line">        <span class="py-keyword">return</span> chunk</span>
<a id="line143"></a><span class="lineno">143</span>
<a id="line144"></a><span class="lineno">144</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Fragments/DeclarationFormatter/DeclarationFormatter.html#format_variable">format_variable</a>(self, decl):</span>
<a id="line145"></a><span class="lineno">145</span>
<a id="line146"></a><span class="lineno">146</span><span class="line">        <span class="py-comment"># TODO: deal with sizes</span></span>
<a id="line147"></a><span class="lineno">147</span><span class="line">        type = self.format_type(decl.vtype)</span>
<a id="line148"></a><span class="lineno">148</span><span class="line">        chunk = <span class="py-string">'%s'</span>%div(<span class="py-string">'synopsis'</span>, type + <span class="py-string">' '</span> + self.label(decl.name))</span>
<a id="line149"></a><span class="lineno">149</span><span class="line">        <span class="py-keyword">if</span> self.xref: chunk += <span class="py-string">' %s'</span>%div(<span class="py-string">'xref'</span>, self.xref.format_class(decl))</span>
<a id="line150"></a><span class="lineno">150</span><span class="line">        <span class="py-keyword">if</span> self.source: chunk += <span class="py-string">' %s'</span>%div(<span class="py-string">'source'</span>, self.source.format_class(decl))</span>
<a id="line151"></a><span class="lineno">151</span><span class="line">        <span class="py-keyword">return</span> chunk</span>
<a id="line152"></a><span class="lineno">152</span>
<a id="line153"></a><span class="lineno">153</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Fragments/DeclarationFormatter/DeclarationFormatter.html#format_const">format_const</a>(self, decl):</span>
<a id="line154"></a><span class="lineno">154</span><span class="line">        <span class="py-string">&quot;(const type, const name = const value)&quot;</span></span>
<a id="line155"></a><span class="lineno">155</span>
<a id="line156"></a><span class="lineno">156</span><span class="line">        type = self.format_type(decl.ctype)</span>
<a id="line157"></a><span class="lineno">157</span><span class="line">        name = self.label(decl.name) + <span class="py-string">&quot; = &quot;</span> + escape(decl.value)</span>
<a id="line158"></a><span class="lineno">158</span><span class="line">        chunk = <span class="py-string">'%s'</span>%div(<span class="py-string">'synopsis'</span>, type + <span class="py-string">' '</span> + name)</span>
<a id="line159"></a><span class="lineno">159</span><span class="line">        <span class="py-keyword">if</span> self.xref: chunk += <span class="py-string">' %s'</span>%div(<span class="py-string">'xref'</span>, self.xref.format_class(decl))</span>
<a id="line160"></a><span class="lineno">160</span><span class="line">        <span class="py-keyword">if</span> self.source: chunk += <span class="py-string">' %s'</span>%div(<span class="py-string">'source'</span>, self.source.format_class(decl))</span>
<a id="line161"></a><span class="lineno">161</span><span class="line">        <span class="py-keyword">return</span> chunk</span>
<a id="line162"></a><span class="lineno">162</span>
<a id="line163"></a><span class="lineno">163</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Fragments/DeclarationFormatter/DeclarationFormatter.html#format_function">format_function</a>(self, decl):</span>
<a id="line164"></a><span class="lineno">164</span><span class="line">        <span class="py-string">&quot;(return type, func + params + exceptions)&quot;</span></span>
<a id="line165"></a><span class="lineno">165</span>
<a id="line166"></a><span class="lineno">166</span><span class="line">        premod = self.format_modifiers(decl.premodifier)</span>
<a id="line167"></a><span class="lineno">167</span><span class="line">        type = self.format_type(decl.return_type)</span>
<a id="line168"></a><span class="lineno">168</span><span class="line">        name = self.label(decl.name, decl.real_name)</span>
<a id="line169"></a><span class="lineno">169</span><span class="line">        <span class="py-comment"># Special C++ functions  TODO: maybe move to a separate ASG formatter...</span></span>
<a id="line170"></a><span class="lineno">170</span><span class="line">        <span class="py-keyword">if</span> decl.file.annotations[<span class="py-string">'language'</span>] == <span class="py-string">'C++'</span> <span class="py-keyword">and</span> len(decl.real_name)&gt;1:</span>
<a id="line171"></a><span class="lineno">171</span><span class="line">            lt = decl.real_name[-2].find(<span class="py-string">'&lt;'</span>) <span class="py-comment"># check whether this is a template</span></span>
<a id="line172"></a><span class="lineno">172</span><span class="line">            sname = lt == -1 <span class="py-keyword">and</span> decl.real_name[-2] <span class="py-keyword">or</span> decl.real_name[-2][:lt]</span>
<a id="line173"></a><span class="lineno">173</span><span class="line">            <span class="py-keyword">if</span> decl.real_name[-1] == sname: type = <span class="py-string">'&lt;i&gt;constructor&lt;/i&gt;'</span></span>
<a id="line174"></a><span class="lineno">174</span><span class="line">            <span class="py-keyword">elif</span> decl.real_name[-1] == <span class="py-string">'~'</span>+sname: type = <span class="py-string">'&lt;i&gt;destructor&lt;/i&gt;'</span></span>
<a id="line175"></a><span class="lineno">175</span><span class="line">            <span class="py-keyword">elif</span> decl.real_name[-1] == <span class="py-string">'(conversion)'</span>: name = <span class="py-string">'(%s)'</span>%type</span>
<a id="line176"></a><span class="lineno">176</span><span class="line">        params = self.format_parameters(decl.parameters)</span>
<a id="line177"></a><span class="lineno">177</span><span class="line">        postmod = self.format_modifiers(decl.postmodifier)</span>
<a id="line178"></a><span class="lineno">178</span><span class="line">        raises = self.format_exceptions(decl)</span>
<a id="line179"></a><span class="lineno">179</span><span class="line">        <span class="py-comment"># prepend the type by the premodifier(s)</span></span>
<a id="line180"></a><span class="lineno">180</span><span class="line">        type = <span class="py-string">'%s %s'</span>%(premod,type)</span>
<a id="line181"></a><span class="lineno">181</span><span class="line">        <span class="py-comment"># Prevent linebreaks on shorter lines</span></span>
<a id="line182"></a><span class="lineno">182</span><span class="line">        <span class="py-keyword">if</span> len(type) &lt; 60:</span>
<a id="line183"></a><span class="lineno">183</span><span class="line">            type = replace_spaces(type)</span>
<a id="line184"></a><span class="lineno">184</span><span class="line">        <span class="py-keyword">if</span> decl.type == <span class="py-string">'attribute'</span>: name = <span class="py-string">'%s %s %s'</span>%(name, postmod, raises)</span>
<a id="line185"></a><span class="lineno">185</span><span class="line">        <span class="py-keyword">else</span>: name = <span class="py-string">'%s(%s) %s %s'</span>%(name, params, postmod, raises)</span>
<a id="line186"></a><span class="lineno">186</span>
<a id="line187"></a><span class="lineno">187</span><span class="line">        chunk = <span class="py-string">'%s'</span>%div(<span class="py-string">'synopsis'</span>, type + <span class="py-string">' '</span> + name)</span>
<a id="line188"></a><span class="lineno">188</span><span class="line">        <span class="py-keyword">if</span> self.xref: chunk += <span class="py-string">' %s'</span>%div(<span class="py-string">'xref'</span>, self.xref.format_class(decl))</span>
<a id="line189"></a><span class="lineno">189</span><span class="line">        <span class="py-keyword">if</span> self.source: chunk += <span class="py-string">' %s'</span>%div(<span class="py-string">'source'</span>, self.source.format_class(decl))</span>
<a id="line190"></a><span class="lineno">190</span>
<a id="line191"></a><span class="lineno">191</span><span class="line">        <span class="py-keyword">return</span> chunk</span>
<a id="line192"></a><span class="lineno">192</span>
<a id="line193"></a><span class="lineno">193</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Fragments/DeclarationFormatter/DeclarationFormatter.html#format_function_template">format_function_template</a>(self, decl):</span>
<a id="line194"></a><span class="lineno">194</span><span class="line">        <span class="py-string">&quot;(return type, func + params + exceptions)&quot;</span></span>
<a id="line195"></a><span class="lineno">195</span>
<a id="line196"></a><span class="lineno">196</span><span class="line">        premod = self.format_modifiers(decl.premodifier)</span>
<a id="line197"></a><span class="lineno">197</span><span class="line">        type = self.format_type(decl.return_type)</span>
<a id="line198"></a><span class="lineno">198</span><span class="line">        name = self.label(decl.name, decl.real_name)</span>
<a id="line199"></a><span class="lineno">199</span><span class="line">        <span class="py-comment"># Special C++ functions  TODO: maybe move to a separate ASG formatter...</span></span>
<a id="line200"></a><span class="lineno">200</span><span class="line">        <span class="py-keyword">if</span> decl.file.annotations[<span class="py-string">'language'</span>] == <span class="py-string">'C++'</span> <span class="py-keyword">and</span> len(decl.real_name)&gt;1:</span>
<a id="line201"></a><span class="lineno">201</span><span class="line">            lt = decl.real_name[-2].find(<span class="py-string">'&lt;'</span>) <span class="py-comment"># check whether this is a template</span></span>
<a id="line202"></a><span class="lineno">202</span><span class="line">            sname = lt == -1 <span class="py-keyword">and</span> decl.real_name[-2] <span class="py-keyword">or</span> decl.real_name[-2][:lt]</span>
<a id="line203"></a><span class="lineno">203</span><span class="line">            <span class="py-keyword">if</span> decl.real_name[-1] == sname: type = <span class="py-string">'&lt;i&gt;constructor&lt;/i&gt;'</span></span>
<a id="line204"></a><span class="lineno">204</span><span class="line">            <span class="py-keyword">elif</span> decl.real_name[-1] == <span class="py-string">'~'</span>+sname: type = <span class="py-string">'&lt;i&gt;destructor&lt;/i&gt;'</span></span>
<a id="line205"></a><span class="lineno">205</span><span class="line">            <span class="py-keyword">elif</span> decl.real_name[-1] == <span class="py-string">'(conversion)'</span>: name = <span class="py-string">'(%s)'</span>%type</span>
<a id="line206"></a><span class="lineno">206</span><span class="line">        params = self.format_parameters(decl.parameters)</span>
<a id="line207"></a><span class="lineno">207</span><span class="line">        postmod = self.format_modifiers(decl.postmodifier)</span>
<a id="line208"></a><span class="lineno">208</span><span class="line">        raises = self.format_exceptions(decl)</span>
<a id="line209"></a><span class="lineno">209</span><span class="line">        <span class="py-comment"># prepend the type by the premodifier(s)</span></span>
<a id="line210"></a><span class="lineno">210</span><span class="line">        type = <span class="py-string">'%s %s'</span>%(premod,type)</span>
<a id="line211"></a><span class="lineno">211</span><span class="line">        <span class="py-comment"># Prevent linebreaks on shorter lines</span></span>
<a id="line212"></a><span class="lineno">212</span><span class="line">        <span class="py-keyword">if</span> len(type) &lt; 60:</span>
<a id="line213"></a><span class="lineno">213</span><span class="line">            type = replace_spaces(type)</span>
<a id="line214"></a><span class="lineno">214</span><span class="line">        <span class="py-keyword">if</span> decl.type == <span class="py-string">'attribute'</span>: name = <span class="py-string">'%s %s %s'</span>%(name, postmod, raises)</span>
<a id="line215"></a><span class="lineno">215</span><span class="line">        <span class="py-keyword">else</span>: name = <span class="py-string">'%s(%s) %s %s'</span>%(name, params, postmod, raises)</span>
<a id="line216"></a><span class="lineno">216</span><span class="line">        <span class="py-comment"># treat template syntax like a premodifier</span></span>
<a id="line217"></a><span class="lineno">217</span><span class="line">        <span class="py-keyword">if</span> decl.template:</span>
<a id="line218"></a><span class="lineno">218</span><span class="line">            templ = <span class="py-string">'template &amp;lt;%s&amp;gt;'</span>%(self.format_parameters(decl.template.parameters),)</span>
<a id="line219"></a><span class="lineno">219</span><span class="line">            templ = div(<span class="py-string">'template'</span>, templ)</span>
<a id="line220"></a><span class="lineno">220</span><span class="line">            type = <span class="py-string">'%s %s'</span>%(templ, type)</span>
<a id="line221"></a><span class="lineno">221</span>
<a id="line222"></a><span class="lineno">222</span><span class="line">        chunk = <span class="py-string">'%s'</span>%div(<span class="py-string">'synopsis'</span>, type + <span class="py-string">' '</span> + name)</span>
<a id="line223"></a><span class="lineno">223</span><span class="line">        <span class="py-keyword">if</span> self.xref: chunk += <span class="py-string">' %s'</span>%div(<span class="py-string">'xref'</span>, self.xref.format_class(decl))</span>
<a id="line224"></a><span class="lineno">224</span><span class="line">        <span class="py-keyword">if</span> self.source: chunk += <span class="py-string">' %s'</span>%div(<span class="py-string">'source'</span>, self.source.format_class(decl))</span>
<a id="line225"></a><span class="lineno">225</span>
<a id="line226"></a><span class="lineno">226</span><span class="line">        <span class="py-keyword">return</span> chunk</span>
<a id="line227"></a><span class="lineno">227</span>
<a id="line228"></a><span class="lineno">228</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Fragments/DeclarationFormatter/DeclarationFormatter.html#format_operation">format_operation</a>(self, decl):</span>
<a id="line229"></a><span class="lineno">229</span>
<a id="line230"></a><span class="lineno">230</span><span class="line">        <span class="py-comment"># Default operation is same as function, and quickest way is to assign:</span></span>
<a id="line231"></a><span class="lineno">231</span><span class="line">        <span class="py-keyword">return</span> self.format_function(decl)</span>
<a id="line232"></a><span class="lineno">232</span>
<a id="line233"></a><span class="lineno">233</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Fragments/DeclarationFormatter/DeclarationFormatter.html#format_operation_template">format_operation_template</a>(self, decl):</span>
<a id="line234"></a><span class="lineno">234</span>
<a id="line235"></a><span class="lineno">235</span><span class="line">        <span class="py-comment"># Default operation is same as function, and quickest way is to assign:</span></span>
<a id="line236"></a><span class="lineno">236</span><span class="line">        <span class="py-keyword">return</span> self.format_function_template(decl)</span>
<a id="line237"></a><span class="lineno">237</span>
<a id="line238"></a><span class="lineno">238</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Fragments/DeclarationFormatter/DeclarationFormatter.html#format_parameter">format_parameter</a>(self, parameter):</span>
<a id="line239"></a><span class="lineno">239</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Returns one string for the given parameter&quot;&quot;&quot;</span></span>
<a id="line240"></a><span class="lineno">240</span>
<a id="line241"></a><span class="lineno">241</span><span class="line">        text = []</span>
<a id="line242"></a><span class="lineno">242</span><span class="line">        <span class="py-comment"># Premodifiers</span></span>
<a id="line243"></a><span class="lineno">243</span><span class="line">        text.extend([span(<span class="py-string">'keyword'</span>, escape(m)) <span class="py-keyword">for</span> m <span class="py-keyword">in</span> parameter.premodifier])</span>
<a id="line244"></a><span class="lineno">244</span><span class="line">        <span class="py-comment"># Param Type</span></span>
<a id="line245"></a><span class="lineno">245</span><span class="line">        id_holder = [parameter.name]</span>
<a id="line246"></a><span class="lineno">246</span><span class="line">        typestr = self.format_type(parameter.type, id_holder)</span>
<a id="line247"></a><span class="lineno">247</span><span class="line">        <span class="py-keyword">if</span> typestr: text.append(typestr)</span>
<a id="line248"></a><span class="lineno">248</span><span class="line">        <span class="py-comment"># Postmodifiers</span></span>
<a id="line249"></a><span class="lineno">249</span><span class="line">        text.extend([span(<span class="py-string">'keyword'</span>, escape(m)) <span class="py-keyword">for</span> m <span class="py-keyword">in</span> parameter.postmodifier])</span>
<a id="line250"></a><span class="lineno">250</span><span class="line">        <span class="py-comment"># Param name</span></span>
<a id="line251"></a><span class="lineno">251</span><span class="line">        <span class="py-keyword">if</span> id_holder <span class="py-keyword">and</span> len(parameter.name) != 0:</span>
<a id="line252"></a><span class="lineno">252</span><span class="line">            text.append(span(<span class="py-string">'variable'</span>, escape(parameter.name)))</span>
<a id="line253"></a><span class="lineno">253</span><span class="line">        <span class="py-comment"># Param value</span></span>
<a id="line254"></a><span class="lineno">254</span><span class="line">        <span class="py-keyword">if</span> len(parameter.value) != 0:</span>
<a id="line255"></a><span class="lineno">255</span><span class="line">            text.append(<span class="py-string">'= %s'</span>%span(<span class="py-string">'value'</span>, escape(parameter.value)))</span>
<a id="line256"></a><span class="lineno">256</span><span class="line">        <span class="py-keyword">return</span> <span class="py-string">' '</span>.join(text)</span>
<a id="line257"></a><span class="lineno">257</span>
<a id="line258"></a><span class="lineno">258</span>
<a id="line259"></a><span class="lineno">259</span><span class="line"><span class="py-keyword">class</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Fragments/DeclarationFormatter/DeclarationSummaryFormatter.html">DeclarationSummaryFormatter</a>(DeclarationFormatter):</span>
<a id="line260"></a><span class="lineno">260</span><span class="line">    <span class="py-string">&quot;&quot;&quot;Derives from BaseStrategy to provide summary-specific methods.</span></span>
<a id="line261"></a><span class="lineno">261</span><span class="line"><span class="py-string">    Currently the only one is format_exceptions&quot;&quot;&quot;</span></span>
<a id="line262"></a><span class="lineno">262</span>
<a id="line263"></a><span class="lineno">263</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Fragments/DeclarationFormatter/DeclarationSummaryFormatter.html#format_exceptions">format_exceptions</a>(self, oper):</span>
<a id="line264"></a><span class="lineno">264</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Returns a reference to the detail if there are any exceptions.&quot;&quot;&quot;</span></span>
<a id="line265"></a><span class="lineno">265</span>
<a id="line266"></a><span class="lineno">266</span><span class="line">        <span class="py-keyword">if</span> len(oper.exceptions):</span>
<a id="line267"></a><span class="lineno">267</span><span class="line">            <span class="py-keyword">return</span> self.reference(oper.name, <span class="py-string">' raises'</span>)</span>
<a id="line268"></a><span class="lineno">268</span><span class="line">        <span class="py-keyword">return</span> <span class="py-string">''</span></span>
<a id="line269"></a><span class="lineno">269</span>
<a id="line270"></a><span class="lineno">270</span>
<a id="line271"></a><span class="lineno">271</span><span class="line"><span class="py-keyword">class</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Fragments/DeclarationFormatter/DeclarationDetailFormatter.html">DeclarationDetailFormatter</a>(DeclarationFormatter):</span>
<a id="line272"></a><span class="lineno">272</span><span class="line">    <span class="py-string">&quot;&quot;&quot;Provide detail-specific Declaration formatting.&quot;&quot;&quot;</span></span>
<a id="line273"></a><span class="lineno">273</span>
<a id="line274"></a><span class="lineno">274</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Fragments/DeclarationFormatter/DeclarationDetailFormatter.html#format_exceptions">format_exceptions</a>(self, oper):</span>
<a id="line275"></a><span class="lineno">275</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Prints out the full exception spec&quot;&quot;&quot;</span></span>
<a id="line276"></a><span class="lineno">276</span>
<a id="line277"></a><span class="lineno">277</span><span class="line">        <span class="py-keyword">if</span> len(oper.exceptions):</span>
<a id="line278"></a><span class="lineno">278</span><span class="line">            raises = span(<span class="py-string">'keyword'</span>, <span class="py-string">'raises'</span>)</span>
<a id="line279"></a><span class="lineno">279</span><span class="line">            exceptions = []</span>
<a id="line280"></a><span class="lineno">280</span><span class="line">            <span class="py-keyword">for</span> exception <span class="py-keyword">in</span> oper.exceptions:</span>
<a id="line281"></a><span class="lineno">281</span><span class="line">                exceptions.append(self.reference(exception.name))</span>
<a id="line282"></a><span class="lineno">282</span><span class="line">            exceptions = span(<span class="py-string">'raises'</span>, <span class="py-string">', '</span>.join(exceptions))</span>
<a id="line283"></a><span class="lineno">283</span><span class="line">            <span class="py-keyword">return</span> <span class="py-string">'%s (%s)'</span>%(raises, exceptions)</span>
<a id="line284"></a><span class="lineno">284</span><span class="line">        <span class="py-keyword">else</span>:</span>
<a id="line285"></a><span class="lineno">285</span><span class="line">            <span class="py-keyword">return</span> <span class="py-string">''</span></span>
<a id="line286"></a><span class="lineno">286</span>
<a id="line287"></a><span class="lineno">287</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Fragments/DeclarationFormatter/DeclarationDetailFormatter.html#format_enum">format_enum</a>(self, enum):</span>
<a id="line288"></a><span class="lineno">288</span>
<a id="line289"></a><span class="lineno">289</span><span class="line">        name = span(<span class="py-string">'keyword'</span>, <span class="py-string">'enum'</span>) + <span class="py-string">' '</span> + self.label(enum.name)</span>
<a id="line290"></a><span class="lineno">290</span><span class="line">        enumors = <span class="py-string">''</span>.join([self.format_enumerator(e) <span class="py-keyword">for</span> e <span class="py-keyword">in</span> enum.enumerators])</span>
<a id="line291"></a><span class="lineno">291</span><span class="line">        <span class="py-keyword">return</span> name + div(<span class="py-string">'enum'</span>, enumors)</span>
<a id="line292"></a><span class="lineno">292</span>
<a id="line293"></a><span class="lineno">293</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Fragments/DeclarationFormatter/DeclarationDetailFormatter.html#format_enumerator">format_enumerator</a>(self, enumerator):</span>
<a id="line294"></a><span class="lineno">294</span>
<a id="line295"></a><span class="lineno">295</span><span class="line">        text = self.label(enumerator.name)</span>
<a id="line296"></a><span class="lineno">296</span><span class="line">        <span class="py-keyword">if</span> len(enumerator.value):</span>
<a id="line297"></a><span class="lineno">297</span><span class="line">            value = <span class="py-string">' = '</span> + span(<span class="py-string">'value'</span>, escape(enumerator.value))</span>
<a id="line298"></a><span class="lineno">298</span><span class="line">        <span class="py-keyword">else</span>:</span>
<a id="line299"></a><span class="lineno">299</span><span class="line">            value = <span class="py-string">''</span></span>
<a id="line300"></a><span class="lineno">300</span><span class="line">        doc = self.processor.documentation.details(enumerator, self.view)</span>
<a id="line301"></a><span class="lineno">301</span><span class="line">        <span class="py-keyword">return</span> div(<span class="py-string">'enumerator'</span>,<span class="py-string">'%s%s%s'</span>%(text, value, doc))</span>
<a id="line302"></a><span class="lineno">302</span>
</pre>
<div class="logo">Generated on Thu Apr 16 16:27:16 2009 by 
<br/>
<a href="http://synopsis.fresco.org" target="_blank"><img src="../../../../../synopsis.png" alt="logo"/> synopsis</a> (version devel)</div>
</body>
</html>
